## optee-os 4.5.0

=== Makefile ===
SHELL = bash

# It can happen that a makefile calls us, which contains an 'export' directive
# or the '.EXPORT_ALL_VARIABLES:' special target. In this case, all the make
# variables are added to the environment for each line of the recipes, so that
# any sub-makefile can use them.
# We have observed this can cause issues such as 'Argument list too long'
# errors as the shell runs out of memory.
# Since this Makefile won't call any sub-makefiles, and since the commands do
# not expect to implicitely obtain any make variable from the environment, we
# can safely cancel this export mechanism. Unfortunately, it can't be done
# globally, only by name. Let's unexport MAKEFILE_LIST which is by far the
# biggest one due to our way of tracking dependencies and compile flags
# (we include many *.cmd and *.d files).
unexport MAKEFILE_LIST

# Automatically delete corrupt targets (file updated but recipe exits with a
# nonzero status). Useful since a few recipes use shell redirection.
.DELETE_ON_ERROR:

include mk/macros.mk
include mk/checkconf.mk

.PHONY: all
all:

.PHONY: mem_usage
mem_usage:

# log and load eventual tee config file
# path is absolute or relative to current source root directory.
ifdef CFG_OPTEE_CONFIG
$(info Loading OPTEE configuration file $(CFG_OPTEE_CONFIG))
include $(CFG_OPTEE_CONFIG)
endif

# If $(PLATFORM) is defined and contains a hyphen, parse it as
# $(PLATFORM)-$(PLATFORM_FLAVOR) for convenience
ifneq (,$(findstring -,$(PLATFORM)))
ops := $(join PLATFORM PLATFORM_FLAVOR,$(addprefix =,$(subst -, ,$(PLATFORM))))
$(foreach op,$(ops),$(eval override $(op)))
endif

# Make these default for now
ARCH            ?= arm
PLATFORM        ?= vexpress
# Default value for PLATFORM_FLAVOR is set in plat-$(PLATFORM)/conf.mk
ifeq ($O,)
O               := out
out-dir         := $(O)/$(ARCH)-plat-$(PLATFORM)
else
out-dir         := $(O)
endif

arch_$(ARCH)	:= y

ifneq ($V,1)
q := @
cmd-echo := true
cmd-echo-silent := echo
else
q :=
cmd-echo := echo
cmd-echo-silent := true
endif

ifneq ($(filter 4.%,$(MAKE_VERSION)),)  # make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
cmd-echo-silent := true
endif
else                                    # make-3.8x
ifneq ($(findstring s, $(MAKEFLAGS)),)
cmd-echo-silent := true
endif
endif

SCRIPTS_DIR := scripts

include core/core.mk

# Platform/arch config is supposed to assign the targets
ta-targets ?= invalid
$(call force,default-user-ta-target,$(firstword $(ta-targets)))

ifeq ($(CFG_WITH_USER_TA),y)
include ldelf/ldelf.mk
define build-ta-target
ta-target := $(1)
include ta/ta.mk
endef
$(foreach t, $(ta-targets), $(eval $(call build-ta-target, $(t))))

# Build user TAs included in this git
ifeq ($(CFG_BUILD_IN_TREE_TA),y)
define build-user-ta
ta-mk-file := $(1)
include ta/mk/build-user-ta.mk
endef
$(foreach t, $(sort $(wildcard ta/*/user_ta.mk)), $(eval $(call build-user-ta,$(t))))
endif
endif

include mk/cleandirs.mk

.PHONY: clean
clean:
	@$(cmd-echo-silent) '  CLEAN   $(out-dir)'
	$(call do-rm-f, $(cleanfiles))
	${q}dirs="$(call cleandirs-for-rmdir)"; if [ "$$dirs" ]; then $(RMDIR) $$dirs; fi
	@if [ "$(out-dir)" != "$(O)" ]; then $(cmd-echo-silent) '  CLEAN   $(O)'; fi
	${q}if [ -d "$(O)" ]; then $(RMDIR) $(O); fi
	${q}rm -f compile_commands.json

.PHONY: cscope
cscope:
	@echo '  CSCOPE  .'
	${q}rm -f cscope.*
	${q}find $(PWD) -name "*.[chSs]" | grep -v export-ta_ | \
		grep -v -F _init.ld.S | grep -v -F _unpaged.ld.S > cscope.files
	${q}cscope -b -q -k

.PHONY: checkpatch checkpatch-staging checkpatch-working
checkpatch: checkpatch-staging checkpatch-working

checkpatch-working:
	${q}./scripts/checkpatch.sh

checkpatch-staging:
	${q}./scripts/checkpatch.sh --cached

## optee-os 4.1.0

=== debian/changelog ===
optee-os (4.1.0-1) unstable; urgency=medium

  * New upstream version 4.1.0

 -- Dylan Aïssi <daissi@debian.org>  Mon, 12 Feb 2024 14:34:33 +0100

optee-os (4.0.0-1) unstable; urgency=medium

  * Initial release. (Closes: #868212)
  * Explain in debian/README.Debian why several embedded libraries are needed.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 09 Jan 2024 11:09:21 +0100

=== debian/control ===
Source: optee-os
Section: devel
Priority: optional
Maintainer: Dylan Aïssi <daissi@debian.org>
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13),
               python3,
               python3-cryptography,
               python3-pyelftools
Vcs-Browser: https://salsa.debian.org/debian/optee-os
Vcs-Git: https://salsa.debian.org/debian/optee-os.git
Homepage: https://www.trustedfirmware.org/projects/op-tee
Rules-Requires-Root: no

Package: optee-os
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: OP-TEE Trusted OS
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the API
 describing how to communicate with a TEE. Those APIs are defined in the
 GlobalPlatform API specifications.

=== debian/rules ===
#!/usr/bin/make -f

# hardening -> relro breaks compilation with error "'-Wl,-z,relro' unknown"
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-relro

%:
	dh $@

override_dh_auto_build:
	# Build for k3-am62x platform
	make PLATFORM=k3-am62x \
	     CFG_ARM64_core=y \
	     CFG_USER_TA_TARGETS=ta_arm64

## optee-os 4.2.0

=== debian/changelog ===
optee-os (4.2.0-3ubuntu1) oracular; urgency=medium

  * Strip -Wl, from LDFLAGS as optee_os calls ld directly.
  * Remove -f flags from LDFLAGS as optee_os is built as -pie.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 09 Jun 2024 17:41:04 +0000

optee-os (4.2.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Tue, 30 Apr 2024 17:07:30 +0200

optee-os (4.2.0-2) experimental; urgency=medium

  * Build new binary package optee-os-dev installing the SDK of optee-os.
    These files are required to package optee-test (see #868216) which
    is the TEE sanity test suite.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 23 Apr 2024 15:24:31 +0200

optee-os (4.2.0-1) unstable; urgency=medium

  * New upstream version 4.2.0
  * Standards-Version: 4.7.0 (no changes needed)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 23 Apr 2024 14:17:13 +0200

optee-os (4.1.0-2) unstable; urgency=medium

  * Refactor debian/rules
  * Build optee-os for QEMU
  * Update debian/copyright
  * Add debian/upstream/metadata

 -- Dylan Aïssi <daissi@debian.org>  Wed, 28 Feb 2024 17:31:33 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

platforms := k3-am62x vexpress-qemu_armv8a

# k3 platform
k3-am62x_CFLAGS   = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro dpkg-buildflags --get CFLAGS)
k3-am62x_CPPFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro dpkg-buildflags --get CPPFLAGS)
k3-am62x_CXXFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro dpkg-buildflags --get CXXFLAGS)
k3-am62x_LDFLAGS  = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro dpkg-buildflags --get LDFLAGS)
k3-am62x_assigns := O=out/arm-plat-k3 CFG_ARM64_core=y CFG_USER_TA_TARGETS=ta_arm64

# qemu platform
vexpress-qemu_armv8a_CFLAGS   = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro,-stackprotector,-format dpkg-buildflags --get CFLAGS)
vexpress-qemu_armv8a_CPPFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro,-stackprotector,-format dpkg-buildflags --get CPPFLAGS)
vexpress-qemu_armv8a_CXXFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro,-stackprotector,-format dpkg-buildflags --get CXXFLAGS)
vexpress-qemu_armv8a_LDFLAGS  = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-relro,-stackprotector,-format dpkg-buildflags --get LDFLAGS)
vexpress-qemu_armv8a_subplatforms := vexpress-qemu_armv8a_non-virt vexpress-qemu_armv8a_virt
vexpress-qemu_armv8a_non-virt_assigns := O=out/arm-plat-vexpress             CFG_TEE_CORE_LOG_LEVEL=3 CFG_TEE_BENCHMARK=n CFG_ARM_GICV3=y CFG_ARM64_core=y CFG_VIRTUALIZATION=n CFG_USER_TA_TARGETS=ta_arm64
vexpress-qemu_armv8a_virt_assigns     := O=out/arm-plat-vexpress-virtualized CFG_TEE_CORE_LOG_LEVEL=3 CFG_TEE_BENCHMARK=n CFG_ARM_GICV3=y CFG_ARM64_core=y CFG_VIRTUALIZATION=y CFG_USER_TA_TARGETS=ta_arm64

define build_platform
	$(eval platform := $(1))
	$(eval debug := $(if $(2), $(2), 0))
	$(eval subplatforms := $(if $($(platform)_subplatforms), $($(platform)_subplatforms), $(platform)))
	# LDFLAGS from dpkg-buildflags are prefixed with -Wl, but optee_os
	# calls ld directly; also, -f flags may not be used without -shared but
	# optee_os is built as -pie
	$(foreach subplatform, $(subplatforms), \
		CROSS_COMPILE=aarch64-linux-gnu-  \
		CFLAGS='$($(platform)_CFLAGS)' CPPFLAGS='$($(platform)_CPPFLAGS)' \
		CXXFLAGS='$($(platform)_CXXFLAGS)' LDFLAGS='$(filter-out -f%,$($(platform)_LDFLAGS:-Wl,%=%))' \
		make PLATFORM=$(platform) $($(subplatform)_assigns) DEBUG=$(debug) V=1; \
	)
endef

%:
	dh $@

override_dh_auto_build: $(platforms)
$(platforms):
	$(call build_platform,$@)

override_dh_auto_clean:
	rm -rf $(CURDIR)/out

## optee-os 4.3.0

=== debian/changelog ===
optee-os (4.3.0-1ubuntu2) oracular; urgency=medium

  * d/rules: remove elf-package-metadata.specs from LDFLAGS (LP: #2074012).

 -- Mitchell Dzurick <mitchell.dzurick@canonical.com>  Wed, 24 Jul 2024 21:42:42 -0700

optee-os (4.3.0-1ubuntu1) oracular; urgency=medium

  * Fix arm64 build by disabling elfpackagemetadata newly introduced in dpkg,
    and not understood by linker

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Jul 2024 12:34:08 +0200

optee-os (4.3.0-1) unstable; urgency=medium

  [ Dylan Aïssi ]
  * New upstream version 4.3.0

  [ Loïc Minier ]
  * Strip -Wl, from LDFLAGS as optee_os calls ld directly. (Closes: #1072948)
  * Remove -f flags from LDFLAGS as optee_os is built as -pie.

 -- Dylan Aïssi <daissi@debian.org>  Fri, 19 Jul 2024 16:30:57 +0200

=== debian/rules ===
--- 
+++ 
@@ -33,7 +33,7 @@
 	$(foreach subplatform, $(subplatforms), \
 		CROSS_COMPILE=aarch64-linux-gnu-  \
 		CFLAGS='$($(platform)_CFLAGS)' CPPFLAGS='$($(platform)_CPPFLAGS)' \
-		CXXFLAGS='$($(platform)_CXXFLAGS)' LDFLAGS='$(filter-out -f%,$($(platform)_LDFLAGS:-Wl,%=%))' \
+		CXXFLAGS='$($(platform)_CXXFLAGS)' LDFLAGS='$(filter-out -f% -specs=/usr/share/dpkg/elf-package-metadata.specs,$($(platform)_LDFLAGS:-Wl,%=%))' \
 		make PLATFORM=$(platform) $($(subplatform)_assigns) DEBUG=$(debug) V=1; \
 	)
 endef

## optee-os 4.4.0

=== debian/changelog ===
optee-os (4.4.0-1) unstable; urgency=medium

  * New upstream version 4.4.0
  * debian/rules: Export CRYPTOGRAPHY_OPENSSL_NO_LEGACY=1

 -- Dylan Aïssi <daissi@debian.org>  Fri, 17 Jan 2025 18:16:39 +0100

## optee-os 4.5.0

=== debian/changelog ===
optee-os (4.5.0-2) unstable; urgency=medium

  * Cherry-pick upstream patch fixing CVE-2025-46733 (Closes: #1109075)

 -- Dylan Aïssi <daissi@debian.org>  Fri, 11 Jul 2025 11:44:01 +0200

optee-os (4.5.0-1) unstable; urgency=medium

  * New upstream version 4.5.0

 -- Dylan Aïssi <daissi@debian.org>  Wed, 22 Jan 2025 21:44:58 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Dylan Aïssi <daissi@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13),
+               device-tree-compiler,
                python3,
                python3-cryptography,
                python3-pyelftools
@@ -23,3 +24,17 @@
  exposed to Trusted Applications and the TEE Client API v1.0, which is the API
  describing how to communicate with a TEE. Those APIs are defined in the
  GlobalPlatform API specifications.
+
+Package: optee-os-dev
+Architecture: arm64
+Depends: ${misc:Depends},
+         python3
+Description: SDK of OP-TEE Trusted OS
+ OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
+ non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
+ technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
+ exposed to Trusted Applications and the TEE Client API v1.0, which is the API
+ describing how to communicate with a TEE. Those APIs are defined in the
+ GlobalPlatform API specifications.
+ .
+ The package includes the SDK which is used for TA development.
